import { Show } from "solid-js";

function DeviceTile(props: { href?: string; name: string; src: string }) {
  return (
    <a href={props.href ?? "/soon"}>
      <h3>{props.name}</h3>
      <Show when={props.src.startsWith("/images")}>
        <img src={props.src} alt={props.name} />
      </Show>
      <Show when={props.src.startsWith("/videos")}>
        <video width="auto" height="auto" autoplay muted loop>
          <source src={props.src} type="video/mp4" />
        </video>
      </Show>
    </a>
  );
}

export default DeviceTile;
